"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getUpdatedActiveIndex;

var _constants = require("../constants");

function skipDisabledOptions(currentIndex, keyCode, results) {
  var newIndex = currentIndex;

  while (results[newIndex] && results[newIndex].disabled) {
    newIndex += keyCode === _constants.UP ? -1 : 1;
  }

  return newIndex;
}

function getUpdatedActiveIndex(currentIndex, keyCode, results) {
  var newIndex = currentIndex; // Increment or decrement index based on user keystroke.

  newIndex += keyCode === _constants.UP ? -1 : 1; // Skip over any disabled options.

  newIndex = skipDisabledOptions(newIndex, keyCode, results); // If we've reached the end, go back to the beginning or vice-versa.

  if (newIndex === results.length) {
    newIndex = -1;
  } else if (newIndex === -2) {
    newIndex = results.length - 1; // Skip over any disabled options.

    newIndex = skipDisabledOptions(newIndex, keyCode, results);
  }

  return newIndex;
}